      program bdf_node_alter3
c=============================================================c
c  This program is intended to extract nodal deflections from c
c  a user-specified *.f06 file from a previous MSC.NASTRAN    c
c  run and add those deflections as initial imperfections to  c
c  the grid data in another user-specified bulk data file.    c
c  This results in a perturbed (initially imperfect) geometry c
c  for imperfection analysis.                                 c
c=============================================================c
      implicit real*8(a-h,o-z),integer(i-n)
      dimension t1(10000),t2(10000),t3(10000)
      character*4 teststring
      character*7 endoffile
      character*30 iname1,iname2,oname
      character*24 text
      character*80 wholelinebdf
      character*132 wholelinef06

c  Read the NASTRAN *.f06 input file name (containing initial deflections)
      write(6,*) 'enter the NASTRAN *.f06 input file name'
      read(5,'(a30)') iname1
      open(unit=11,file=iname1,status='old')

c  Read the NASTRAN bulk data input file name (containing perfect geometry to be altered)
      write(6,*) 'enter the NASTRAN *.bdf input file name'
      read(5,'(a30)') iname2
      open(unit=12,file=iname2,status='old')

c  Enter the NASTRAN bulk data output file name (to contain altered geometry)
      write(6,*) 'enter the NASTRAN *.bdf output file name'
      read(5,'(a30)') oname
      open(unit=21,file=oname,status='unknown')

c  Scan *.f06 file for displacement data and read
      write(6,*) 'enter the number of nodes in the model'
      read(5,*) nn
      nsec=int(nn/50)
      do while(wholelinef06(48:57) .ne. 'END OF JOB')
        read(11,'(a132)') wholelinef06
        if(wholelinef06(46:50) .eq. 'D I S')then
          read(11,'(a132)') wholelinef06
          read(11,'(a132)') wholelinef06
          k=0
          do 20 i=1,nsec
            do 10 j=1,50
              k=k+1
              read(11,100) junk2,t1(k),t2(k),t3(k),r1,r2,r3
10          continue
            read(11,'(a132)') wholelinef06
            read(11,'(a132)') wholelinef06
            read(11,'(a132)') wholelinef06
            read(11,'(a132)') wholelinef06
            read(11,'(a132)') wholelinef06
            read(11,'(a132)') wholelinef06
            read(11,'(a132)') wholelinef06
20        continue
          do 30 i=nsec*50+1,nn
            k=k+1
            read(11,100) junk2,t1(k),t2(k),t3(k),r1,r2,r3
30        continue
        endif
      end do
      close(11)

c  Alter GRID coordinate definitions for each node
      k=0
      read(12,'(a80)') wholelinebdf
      write(21,'(a80)') wholelinebdf
      do 40 i=1,nn
        k=k+1
        read(12,200,end=50) text,x,y,z
        x=x+t1(k)
        y=y+t2(k)
        z=z+t3(k)
        write(21,200) text,x,y,z
40    continue
      if(k .ne. nn)then
        write(6,*) '*.f06 and *.bdf missmatch in number of nodes'
      endif
      go to 60
50    continue
      write(6,*) '*.f06 and *.bdf missmatch in number of nodes'
60    continue
      close(12)
      close(21)

100   format(a26,6(e13.6,2x))
200   format(a24,3(f8.5))

      stop
      end

